PROGRAM einkaufsliste
  IMPLICIT NONE

  TYPE produkt
    CHARACTER(15) :: pname
    INTEGER(1) :: pmenge
    TYPE(produkt), POINTER :: next
  END TYPE

  TYPE liste
    INTEGER :: laenge
    TYPE(produkt), POINTER :: head => null()
  END TYPE

  TYPE(liste) :: einkauf

  CALL schreiben(einkauf)
  CALL einkaufen(einkauf)

CONTAINS

  !Die SUBROUTINEs und TYPE Definitionen können auch in ein MODULE ausgelagert werden

  SUBROUTINE schreiben(einkauf)
    TYPE(liste) :: einkauf
    TYPE(produkt), POINTER :: p  !als help/tail-pointer 
    INTEGER :: i
    DO
      WRITE(*,*) 'Wie viele verschiedene Produkte wirst du einkaufen?'
      READ(*,*) einkauf%laenge
      IF (einkauf%laenge >= 2) EXIT
    END DO

    ALLOCATE(p)
    WRITE(*,*) 'Bitte erstes Lebensmittel und Menge eingeben.'
    READ(*,*) p%pname, p%pmenge

    einkauf%head => p

    DO i = 2, einkauf%laenge
      ALLOCATE(p%next)
      p => p%next
      WRITE(*,*) 'Bitte naechstes Lebensmittel und Menge eingeben.'
      READ(*,*) p%pname, p%pmenge
    END DO
  END SUBROUTINE

  ! Ausgabe unter Verwendung von laenge-Komponente
  SUBROUTINE einkaufen(eineliste)
    TYPE(liste) :: eineliste
    TYPE(produkt), POINTER :: q
    INTEGER :: i

    q => eineliste%head

    DO i = 1, eineliste%laenge
      WRITE(*,*) 'Du legst', q%pmenge, ' mal ', TRIM(q%pname), ' in den Einkaufswagen.'
      q => q%next
    END DO
  END SUBROUTINE

  ! Ausgabe OHNE Laenge der Liste zu verwenden:
  SUBROUTINE einkaufen2(eineliste)
    TYPE(liste) :: eineliste
    TYPE(produkt), POINTER :: q
    INTEGER :: i

    q => eineliste%head

    DO
      IF (ASSOCIATED(q)) THEN
        WRITE(*,*) 'Du legst', q%pmenge, ' mal ', TRIM(q%pname), ' in den Einkaufswagen.'
        q => q%next
      ELSE
        EXIT
      END IF
    END DO
  END SUBROUTINE

END PROGRAM
