PROGRAM Taschenrechner
  IMPLICIT NONE

	REAL:: x,y
    INTEGER :: n, a, b, k, c, v, s
	CHARACTER:: Operation
	
	DO
	
		WRITE(*,*) 'Gib eine Operation an'
		WRITE(*,*) 'Schreibe + (Addition), - (Subtraktion), % (Division), * (Multiplikation), k (Kreisfläche), q (Quader), '
        WRITE(*,*) 'd (Dreieckszahl), p (Potenzieren), b (Binomialkoeffizient)'
		READ(*,*) Operation
	
		SELECT CASE (Operation)
			CASE('+')
					WRITE(*,*) 'Gib zwei Summanden ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' + ', y, ' = ', x+y
			CASE('-')
					WRITE(*,*) 'Gib Minuend und Subtrahend ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' - ', y, ' = ',x-y
		
			CASE('*')
					WRITE(*,*) 'Gib zwei Faktoren ein'
					READ(*,*) x,y
					WRITE(*,*) x, ' * ', y, ' = ', x*y
			CASE('%')
					WRITE(*,*) 'Gib Dividend und Divisor ein'
					READ(*,*) x,y
					IF (y==0) THEN
				 		WRITE(*,*) 'Teilung durch 0 ist verboten!'
					ELSE
						WRITE(*,*) x, ' / ', y, ' = ', x/y
					END IF
			CASE('k')
					WRITE(*,*) 'Gib einen Radius ein!'
					READ(*,*) x
					IF (x<0) THEN
				 		WRITE(*,*) 'Der Radius soll positiv sein!'
					ELSE
						write(*,*) 'Die Flaeche betraegt ', area(x)
                        write(*,*) 'Der Radius betraegt nun ', x
					END IF
            CASE('q')
					WRITE(*,*) 'Gib die drei Seitenlaengen ein ein!'
					READ(*,*) a, b, c
					IF (a<=0 .OR. b<=0 .OR. c<=0) THEN
				 		WRITE(*,*) 'Die Werte muessen positiv sein!'
					ELSE
                        CALL quader(a, b, c, v, s)
						write(*,*) 'Das Volumen betraegt ', v
                        write(*,*) 'Die Oberflaeche betraegt ', s
					END IF
            CASE('d')
                    WRITE(*,*) 'Bitte n eingeben.'
                    READ(*,*) n
                    WRITE(*,*) 'Die ', n, 'te Dreieckszahl ist ', dreieck(n)
            CASE('p')
                    WRITE(*,*) 'Bitte a und b eingeben.'
                    READ(*,*) a, b
                    WRITE(*,*) a, '^', b, '=', potenz(a,b)
            CASE('b')
                    WRITE(*,*) 'Bitte n und k eingeben.'
                    READ(*,*) n, k
                    WRITE(*,*) n, ' über ', k, ' = ', binom(n, k)
			CASE DEFAULT
					WRITE(*,*) 'Ungültige Eingabe!'
					EXIT
		END SELECT
		
	END DO

CONTAINS

  FUNCTION area (radius)
    REAL :: area, radius
    REAL, PARAMETER :: pi = 3.14159

    area = pi * radius**2
    radius = 500

  END FUNCTION

  SUBROUTINE quader (a, b, c, volume, surface)
    INTEGER :: a, b, c, volume, surface

    volume = a * b * c
    surface = 2 * (a*b + b*c + a*c)
  END SUBROUTINE

  RECURSIVE FUNCTION dreieck (n) RESULT(res)
    INTEGER :: n, res

    IF (n == 1) THEN
        res = 1
    ELSE
        res = n + dreieck(n-1)
    END IF
  END FUNCTION

  RECURSIVE FUNCTION potenz (a, b) RESULT(res)
    INTEGER :: a, b, res

    IF (b == 1) THEN
        res = a
    ELSE
        res = a * potenz(a, b-1)
    END IF
  END FUNCTION

  RECURSIVE FUNCTION binom (n, k) RESULT(res)
    INTEGER :: n, k, res

    IF (k == 0) THEN
        res = 1
    ELSEIF (k == 1) THEN
        res = n
    ELSEIF (k == n) THEN
        res = 1
    ELSE
        res = binom(n-1,k-1) + binom(n-1, k)
    END IF
  END FUNCTION

END PROGRAM
