program QueueProgram

    implicit none
    
    type :: Queue
        type(QueueElement), pointer:: head => null()
        type(QueueElement), pointer:: tail => null()
    end type Queue

    type :: QueueElement
        character(len=20):: name = ""
        type(QueueElement), pointer:: next => null()
    end type QueueElement


    type(Queue)     :: myQueue 
    character(20)   :: name

    name = "Bilbo"
    call enqueue(myQueue, name)
    name = "Frodo"
    call enqueue(myQueue, name)

    call dequeue(myQueue, name)
    write(*,*) name

    name = "Gimli"
    call enqueue(myQueue, name)

    name = "Legolas"
    call enqueue(myQueue, name)
    
    call traverse(myQueue, toCAPS)

    call dequeue(myQueue, name)
    write(*,*) name
    call dequeue(myQueue, name)
    write(*,*) name
    call dequeue(myQueue, name)
    write(*,*) name

    

    contains
        subroutine enqueue(myQueue, name)
            type(Queue), intent(inout)  :: myQueue 
            type(QueueElement), pointer :: newQueueElement 
            character(20), intent(in)   :: name

            allocate(newQueueElement)
            newQueueElement%name = name

            if(.not.associated(myQueue%head)) then
                myQueue%head => newQueueElement
            else
                myQueue%tail%next => newQueueElement
            end if

            myQueue%tail => newQueueElement
        end subroutine enqueue


        subroutine dequeue(myQueue, name)
            type(Queue), intent(inout)              :: myQueue 
            type(QueueElement), pointer             :: deleteQueueElement 
            character(20), intent(out), optional    :: name

            if(associated(myQueue%head)) then

                if(associated(myQueue%head, myQueue%tail)) then
                    myQueue%tail => null()
                end if

                deleteQueueElement => myQueue%head
                myQueue%head => deleteQueueElement%next

                if(present(name))then
                    name = deleteQueueElement%name
                end if

                deallocate(deleteQueueElement)
            end if
        end subroutine dequeue

        subroutine traverse(myQueue, task)            
            type(Queue), intent(inout)  :: myQueue 
            type(QueueElement), pointer :: current

            interface 
                subroutine task(name)
                    character(20), intent(inout):: name
                end subroutine task
            end interface


            current => myQueue%head

            do while(associated(current))
                call task(current%name)
                current => current%next
            end do
            
        end subroutine traverse


        subroutine toCAPS(word)
            character(20), intent(inout):: word 
            integer :: i
            integer, parameter :: dif = iachar("A") - iachar("a")

            do i=1, len_trim(word)
                if("a" <= word(i:i) .and. word(i:i) <= "z") then
                    word(i:i) = achar(iachar(word(i:i)) + dif)
                end if
            end do
            
        end subroutine toCAPS

        subroutine task2(i)
            integer, intent(inout)  :: i
            i = i + 1 
        end subroutine task2
end program QueueProgram
